/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/common/flashLed.S
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   
     
#include <xs1.h>
 
.text
.align    4
.globl flashLed
.globl flashLed.nstackwords
.linkset flashLed.nstackwords, 6
flashLed:
        entsp     0x6 
          stw       r4, sp[0x1] 
          stw       r5, sp[0x2] 
          stw       r6, sp[0x3] 
          stw       r7, sp[0x4]
          stw       r8, sp[0x5] 
          mov       r8, r0             // r8: port
         
          mov       r4, r1             // r4: onpulse
          mov       r7, r2             // r7: offpulse            
          ldw       r6, sp[0x7]        // r6: onVal 
          
#if defined XC-1
          shl       r6, r6, 4          // On the XC1, the leds are on the upper 4 bits of a 8bit port
#elif defined XC-5
          // Shuffle around the key leds, 3210 -> 1230
          ldc       r1, 0x1
          and       r1, r6,  r1
          
          shr       r6, r6,   1
          bitrev    r6, r6
          shr       r6, r6,  24
          shr       r6, r6,   4

          or        r6, r6,  r1
#endif
          getr      r5, XS1_RES_TYPE_TIMER
          bf        r3, return
loop:
          out       res[r8], r6 
          mov       r1, r4
          mov       r0, r5
          bl        wait 
          ldc       r11, 0x0
          out       res[r8], r11 
          mov       r1, r7
          mov       r0, r5
          bl        wait 
          sub       r3, r3, 0x1        // Shouldn;t really use r3
          bt        r3, loop 
return:
          freer     res[r5]
          ldw       r4, sp[0x1] 
          ldw       r5, sp[0x2] 
          ldw       r6, sp[0x3]
          ldw       r7, sp[0x4] 
          ldw       r8, sp[0x5] 
          retsp     0x6 

