/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/common/include/xc2.h
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   
/*
 * XC2 resource defines
 *
 */

#ifndef _xc2_h_
#define _xc2_h_

#include <xs1.h>

/*** All cores ***/
#define PORT_LED_A       XS1_PORT_1I
#define PORT_LED_B       XS1_PORT_1J

/*** Core 0 ***/
#define PORT_SPI_SS      XS1_PORT_1B
#define PORT_SPI_MISO    XS1_PORT_1A
#define PORT_SPI_SCLK    XS1_PORT_1C
#define PORT_SPI_MOSI    XS1_PORT_1D
#define PORT_KEYLED_A    XS1_PORT_1E
#define PORT_KEYLED_B    XS1_PORT_1F
#define PORT_KEY_A       XS1_PORT_4C
#define PORT_KEY_B       XS1_PORT_4D
#define PORT_UART_DN     XS1_PORT_1G
#define PORT_UART_UP     XS1_PORT_1H

/*** Core 1 expansion IO only ***/

/*** Core 2 ***/
#define CLK_MII_RX       XS1_CLKBLK_1
#define CLK_MII_TX       XS1_CLKBLK_2
#define CLK_SMI          XS1_CLKBLK_3
#define PORT_MII_RXCLK   XS1_PORT_1M
#define PORT_MII_RXD     XS1_PORT_4E
#define PORT_MII_RXDV    XS1_PORT_1N
#define PORT_MII_TXCLK   XS1_PORT_1K
#define PORT_MII_TXEN    XS1_PORT_1L
#define PORT_MII_TXD     XS1_PORT_4F
#define PORT_MII_RST_N   XS1_PORT_1G
#define PORT_MII_MDC     XS1_PORT_1P
#define PORT_MII_RXER    XS1_PORT_1O
/* TXER not wired */
/* RST_N at PORT_8D[6] */
/* MDIO at PORT_8D[7] */

/*** Core 3 expansion IO only ***/

#endif
