/**
 * Module:  firmware
 * Version: 1v2
 * Build:   6ee030bb6889ef7fa8bd871765d4954233229644
 * File:    src/common/softReset/appSoftReset.S
 *
 * The copyrights, all other intellectual and industrial 
 * property rights are retained by XMOS and/or its licensors. 
 * Terms and conditions covering the use of this code can
 * be found in the Xmos End User License Agreement.
 *
 * Copyright XMOS Ltd 2009
 **/                                   
#include "xs1_kernel.h"
//#define __assembler
//#include "appSoftReset.h"
 
#define SOFT_RESET_MAGIC_VALUE 0xABCD0000
#define SOFT_RESET_INVALID_VALUE 0x12345678
#define SOFT_RESET_BOOT_JTAG 0xFF
   
// Function to invalidate next application number
    .globl _InvalidateAppNum, "f{}(0)"
    .globl _InvalidateAppNum.nstackwords
    .globl _InvalidateAppNum.maxchanends
    .globl _InvalidateAppNum.maxtimers
    .globl _InvalidateAppNum.maxthreads
    .linkset _InvalidateAppNum.nstackwords, 5
    .linkset _InvalidateAppNum.maxchanends, 0
    .linkset _InvalidateAppNum.maxtimers, 0
    .linkset _InvalidateAppNum.maxthreads, 0
    .text
    .align 2
_InvalidateAppNum:
  ldap     r11, _nextAppIDAddr
  ldw      r0, r11[0]
	ldap     r11, _invalidAppIDValue
	ldw      r1, r11[0]
  stw      r1, r0[0]
	retsp    0


// Function to store the number of the next application to be executed into
// kernel stack space    
    .globl _SetNextAppNum, "f{0}(ui)"
    .globl _SetNextAppNum.nstackwords
    .globl _SetNextAppNum.maxchanends
    .globl _SetNextAppNum.maxtimers
    .globl _SetNextAppNum.maxthreads
    .linkset _SetNextAppNum.nstackwords, 5
    .linkset _SetNextAppNum.maxchanends, 0
    .linkset _SetNextAppNum.maxtimers, 0
    .linkset _SetNextAppNum.maxthreads, 0
    .text
    .align 2
_SetNextAppNum:
  entsp 5
  
  
  ldap r11,       _nextAppIDAddr
  ldw r11,        r11[0]
  stw r0,         r11[0]
  
  retsp 5
  

// Function to read the number of the next application to be executed into
// kernel stack space    
    .globl _GetNextAppNum, "f{ui}(0)"
    .globl _GetNextAppNum.nstackwords
    .globl _GetNextAppNum.maxchanends
    .globl _GetNextAppNum.maxtimers
    .globl _GetNextAppNum.maxthreads
    .linkset _GetNextAppNum.nstackwords, 5
    .linkset _GetNextAppNum.maxchanends, 0
    .linkset _GetNextAppNum.maxtimers, 0
    .linkset _GetNextAppNum.maxthreads, 0
    .text
    .align 2
_GetNextAppNum:
  entsp 5
  
  ldap r11,       _nextAppIDAddr
  ldw r11,        r11[0]
  ldw r0,         r11[0]
  
  retsp 5  

.align 4
_invalidAppIDValue:
.word SOFT_RESET_INVALID_VALUE
_nextAppIDAddr:
    .word XS1_RAM_BASE + XS1_RAM_SIZE - 32 // use top of kernel stack space
